if (typeof(sack) != 'undefined') {
	var gengo = new sack(script_uri);
	gengo.method = 'POST';
}

function gengo_delete_button_replacement() {
	if (document.getElementById('gengo_delete_all_translations').checked == true) return confirm(delete_all_message);
	else return confirm(delete_single_message);
}

function gengo_all_delete_all_checkbox() {
	addLoadEvent
	(
		function()
		{
			var deletebutton = document.getElementById('deletepost');
			deletebutton.parentNode.appendChild(document.getElementById('gengo_delete_translations_block'));
			deletebutton.onclick = function() { return gengo_delete_button_replacement(); };
		}
	);
}

function gengo_resolve_clashes(language_id) {
  var this_clash_array = document.forms['gengo_group_form']['lang_clash_' + language_id];
	for (i = 0; i < this_clash_array.length; i++) {
		var clash_id = this_clash_array[i].value;
		if (this_clash_array[i].checked == true) document.getElementById('sum_block_' + clash_id).style.background = '#e9e9e9';
		else document.getElementById('sum_block_' + clash_id).style.background = '#ffebeb';
	}

	var resolved_clash_ids = '';
	var removed_clash_ids = '';
	for (i = 0; i < languages.length; i++) {
		if (clashes[languages[i]] == false) continue;
		var resolved = false;
		for (j = 0; j < document.forms['gengo_group_form']['lang_clash_' + languages[i]].length; j++) {
			if (document.forms['gengo_group_form']['lang_clash_' + languages[i]][j].checked == true) {
			  if (resolved_clash_ids != '') resolved_clash_ids += ',';
			  resolved_clash_ids += document.forms['gengo_group_form']['lang_clash_' + languages[i]][j].value;
				resolved = true;
			} else {
			  if (removed_clash_ids != '') removed_clash_ids += ',';
				removed_clash_ids += document.forms['gengo_group_form']['lang_clash_' + languages[i]][j].value;
			}
		}
		if (resolved == false) return false;
	}
	document.getElementById('gengo_resolved_summary_clashes').value = resolved_clash_ids;
	document.getElementById('gengo_removed_summary_clashes').value = removed_clash_ids;
	document.getElementById('gengo_create_group_submit').disabled = false;
}

function gengo_get_translation_group_components(post_id) {
	if (gengo.failed) return false;

	var gengo_response = document.getElementById('gengo_group_components_block');
	var post_id_string = '';
	var selectors = document.getElementsByName('gengo_constituent_posts[]');
	var selected = 0;

	for (i = 0; i < selectors.length; i++) {
		var lang_id = selectors[i].id.substring(11);
		for (j = 0; j < languages.length; j++) document.getElementById(lang_id + '_' + languages[j]).innerHTML = '';
		if (selectors[i].value != 0)
		{
			post_id_string += '&post_ids[]=' + selectors[i].value;
			selected++;
		}
	}
	document.getElementById('gengo_create_group_submit').disabled = true;

	if (!selected) return false;

	document.getElementById('gengo_create_group_updating').style.display = 'block';
	gengo.onCompletion = function() {
		for (i = 0; i < clashes.length; i++) clashes[i] = false;
	  var summary_info = gengo.response.split('GENGO_SEPARATOR');
	  if (summary_info.length > 1) {
			for (i = 0; i < summary_info.length; i = i + 3) {
				document.getElementById(summary_info[i]).innerHTML = summary_info[i + 1];
				if (summary_info[i + 2] != 0) clashes[summary_info[i + 2]] = true;
			}
		}
		document.getElementById('gengo_create_group_updating').style.display = 'none';
		for (i = 0; i < languages.length; i++) if (clashes[languages[i]] == true) return;
		if (selected > 1) document.getElementById('gengo_create_group_submit').disabled = false;
	};
	gengo.runAJAX('gengo_ajax=true&gengo_action=ajax_get_group_components' + post_id_string);
}

function gengo_set_synonym_checkbox(id) {
	document.getElementById('check_' + id).checked = true;
}

function gengo_get_synblock(block_name) {
	if (block_name == -1) {
		for (i = 0; i < languages.length; i++) document.getElementById('synblock_' + languages[i]).innerHTML = '';
		document.getElementById('gengo_new_synblock_block').style.display = 'inline';
		document.getElementById('gengo_synblock_submit').value = add_button_text;
		document.getElementById('deletepost').style.display = 'none';
		document.getElementById('gengo_new_synblock').value = '';
		return true;
	}
	document.getElementById('gengo_synblock_updating').style.display = 'block';
	document.getElementById('gengo_new_synblock_block').style.display = 'none';
	document.getElementById('deletepost').style.display = 'inline';
	document.getElementById('gengo_synblock_submit').value = update_button_text;
	if (gengo.failed) return false;
	document.getElementById('gengo_synblock_name').disabled = true;
	gengo.onCompletion = function() {
		if (gengo.response == '') {
			for (i = 0; i < languages.length; i++) document.getElementById('synblock_' + languages[i]).innerHTML = '';
	  } else {
			var summary_info = gengo.response.split('GENGO_SEPARATOR');
			for (i = 0; i < summary_info.length; i = i + 2) document.getElementById('synblock_' + summary_info[i]).innerHTML = summary_info[i + 1];
		}
		document.getElementById('gengo_synblock_name').disabled = false;
		document.getElementById('gengo_synblock_updating').style.display = 'none';
	};
	gengo.runAJAX('gengo_ajax=true&gengo_action=ajax_get_synblock&block_name=' + block_name);
}

function gengo_select_language() {
	var codes = document.getElementById('gengo_recognised_languages');

	if (codes.value == -1) {
		return;
	} else {
		var name = document.getElementById('gengo_language');
		var langname = codes.options[codes.selectedIndex].text
		var length = codes.value.indexOf('-');
		name.value = (-1 != (position = langname.indexOf('/'))) ? langname.substr(0, position) : langname;
		var code = codes.value.substr(0, length);
		document.getElementById('gengo_language_code').value = code;
		document.getElementById('gengo_language_locale').value = codes.value.substr(length + 1);
		document.getElementById('gengo_language_rtl').checked = (rtl_scripts.in_array(code)) ? true : false;
		document.getElementById('gengo_language_blog_title').focus();
	}
}

function gengo_delete_summary(summary_id, summary_group) {
	if (!summary_group || !summary_id) return false;
	if (gengo.failed) return false;
	if (!confirm(delete_summary_message)) return false;
	gengo.onCompletion = function() {
		gengo_refresh_summary_list();
	};
	gengo.runAJAX('gengo_ajax=true&gengo_action=ajax_delete_summary&summary_group=' + summary_group + '&summary_id=' + summary_id);
}

function gengo_update_summary() {
	var summary_id = document.getElementById('gengo_summary_id').value;
	var summary_content = document.getElementById('gengo_summary_content').value;
	var summary_group = document.getElementById('gengo_summary_group').value;

	if (gengo.failed) return false;
	gengo.onCompletion = function() {
		document.getElementById('gengo_summary_message').innerHTML = '<em>' + updated_summary_message + '</em>';
		document.getElementById('gengo_summary_update').style.display = 'none';
		if (summary_id == 0 && summary_group == 0) document.getElementById('gengo_existing_summary_group').value = gengo.response;
		gengo_refresh_summary_list();
	};
	if (summary_id != 0) {
		gengo.runAJAX('gengo_ajax=true&gengo_action=ajax_update_summary_content&summary_id= ' + summary_id + '&summary_content=' + summary_content);
	} else {
		var language_id = document.getElementById('gengo_summary_language_id').value;
		gengo.runAJAX('gengo_ajax=true&gengo_action=ajax_add_summary_content&post_id=' + existing_post_id + '&summary_group=' + summary_group + '&language_id=' + language_id + '&summary_content=' + summary_content + '&translation_group=' + existing_translation_group);
	}
}

function gengo_refresh_summary_list() {
	var gengo_response = document.getElementById('gengo_summary_block');
	var existing_summary_group = document.getElementById('gengo_existing_summary_group').value;
	var is_in_group = 'false';
	var translation_number = 0;

	if (document.getElementById('gengo_translation').checked == true) {
		for (i = 0; i < document.post.gengo_translation_group.length; i++) {
			if (document.post.gengo_translation_group[i].checked) {
				val = document.post.gengo_translation_group[i].value;
				if (val != 0) {
					is_in_group = 'true';
					translation_number = val;
					document.getElementById('gengo_translation_content_block').style.display = 'none';
				} else {
					is_in_group = 'false';
					translation_number = document.getElementById('gengo_translation_post').value;
				}
				break;
			}
		}
	}
	if (gengo.failed) return false;
	gengo.onCompletion = function() {
		gengo_response.innerHTML = gengo.response;
		document.getElementById('gengo_summary_content_block').style.display = 'none';
		gengo_unlock_controls();
	};
	gengo.runAJAX('gengo_ajax=true&gengo_action=ajax_refresh_summary_lists&post_id=' + existing_post_id + '&summary_group=' + existing_summary_group + '&is_in_group=' + is_in_group + '&translation_number=' + translation_number);
}

function gengo_lock_controls() {
	if (null != (save = document.getElementById('save'))) save.disabled = true;
	if (null != (savepage = document.getElementById('savepage'))) savepage.disabled = true;
	if (null != (publish = document.getElementById('publish'))) publish.disabled = true;

	document.getElementById('gengo_sidebar_title').innerHTML = sidebar_updating_title;
	document.getElementById('gengo_sidebar_group').style.display = 'none';
	document.getElementById('gengo_sidebar_updating').style.display = 'block';
}

function gengo_unlock_controls() {
	if (null != (save = document.getElementById('save'))) save.disabled = false;
	if (null != (savepage = document.getElementById('savepage'))) savepage.disabled = false;
	if (null != (publish = document.getElementById('publish'))) publish.disabled = false;

	document.getElementById('gengo_sidebar_title').innerHTML = sidebar_title;
	document.getElementById('gengo_sidebar_updating').style.display = 'none';
	document.getElementById('gengo_sidebar_group').style.display = 'block';
}

function gengo_show_summary_content_block(summary_id) {
	document.getElementById('gengo_summary_id').value = summary_id;
	if (summary_id == 0) {
		var language_id = document.getElementById('gengo_new_summary').value;
		document.getElementById('gengo_summary_legend').innerHTML = '<legend>' + summary_title + ' (' + language_names[language_id] + ')</legend>';
	  document.getElementById('gengo_summary_content').value = '';
		document.getElementById('gengo_summary_language_id').value = language_id;
		document.getElementById('gengo_summary_message').innerHTML = '';
		document.getElementById('gengo_summary_content_block').style.display = 'block';
		return;
	}
	var gengo_response = document.getElementById('gengo_summary_content');

	if (gengo.failed) return false;
	gengo.onCompletion = function() {
		var summary_info = gengo.response.split('GENGO_SEPARATOR');
		gengo_response.value = summary_info[1];
		document.getElementById('gengo_summary_legend').innerHTML = '<legend>' + summary_title + ' (' + language_names[summary_info[0]] + ')</legend>';
		document.getElementById('gengo_summary_language_id').value = summary_info[0];
		document.getElementById('gengo_summary_message').innerHTML = '';
		document.getElementById('gengo_summary_content_block').style.display = 'block';
	};
	gengo.runAJAX('gengo_ajax=true&gengo_action=ajax_get_summary_content&summary_id=' + summary_id);
}

function gengo_show_translation_content_block(translation_id) {
	gengo_lock_controls();
	if (isNaN(translation_id)) {
		document.getElementById('gengo_translation_content_block').style.display = 'none';
		gengo_refresh_summary_list();
		return;
	}
	var gengo_response = document.getElementById('gengo_translation_content');

	if (gengo.failed) return false;
	gengo.onCompletion = function() {
		alert(gengo.response);
		var post_info = gengo.response.split('GENGO_SEPARATOR');
		if (post_info[2] == 1) {
			gengo_response.readOnly = true;
			readonly = ' <em>(' + readonly_message + ')</em>';
		} else {
			gengo_response.readOnly = false;
			readonly = '';
		}
		document.getElementById('gengo_translation_legend').innerHTML = '<legend>' + translation_title + ' (' + post_info[1] + ')' + readonly + '</legend>';
		document.getElementById('gengo_translation_content').dir = rtl[post_info[0]];
		gengo_response.value = post_info[3];
		gengo_refresh_summary_list();
		document.getElementById('gengo_translation_content_block').style.display = 'block';
	};
	gengo.runAJAX('gengo_ajax=true&gengo_action=ajax_get_translation_post&post_id=' + translation_id);
}

function gengo_update_translation_options(first_post, first_group) {
	gengo_lock_controls();
	var gengo_response = document.getElementById('gengo_translation_block');
	var post_language_id = document.getElementById('gengo_use_language').value;
	if (!first_post) first_post = 0;
	if (!first_group) first_group = 0;

	document.getElementById('gengo_translation_content_block').style.display = 'none';

	if (gengo.failed) return false;
	gengo.onCompletion = function() {
		gengo_response.innerHTML = gengo.response;
		gengo_refresh_summary_list();
	};
	gengo.runAJAX('gengo_ajax=true&gengo_action=ajax_update_translation_options&post_language_id=' + post_language_id + '&post_id=' + existing_post_id + '&post_translation_group=' + existing_translation_group + '&first_post=' + first_post + '&first_group=' + first_group);
}

function gengo_update_translation_content() {
	var translation_id = document.getElementById('gengo_translation_post').value;
	var translation_content = document.getElementById('gengo_translation_content').value;

	if (gengo.failed) return false;
	gengo.onCompletion = function() {
		document.getElementById('gengo_translation_message').innerHTML = '<em>' + translation_updated_message + '</em>';
		document.getElementById('gengo_update_button').style.display = 'none';
	};
	gengo.runAJAX('gengo_ajax=true&gengo_action=ajax_update_translation_content&translation_id=' + translation_id + '&translation_content=' + translation_content);
}

function gengo_change_language() {
	var new_language = document.getElementById('gengo_use_language');
	document.getElementById('content').dir = rtl[new_language.value];
	document.getElementById('title').dir = rtl[new_language.value];
	gengo_update_translation_options();
}